#include "Application.h"
#include "Core/IoContext.h"
#include "Core/Singleton.h"
#include "Settings.h"

namespace Older {
Application::Application() {
    using namespace Core;
    m_settings = Singleton<Settings>::construct();

    m_ioContext = Singleton<IoContext>::construct(m_settings->threads());
}

boost::asio::io_context &Application::ioContext() {
    return *m_ioContext->ioContext();
}

int Application::exec() {
    m_ioContext->run();
    return 0;
}
} // namespace Older
